%% autoPub2

%%

close all
clear

load board1


imageFileNames = board.FullPathNames;
imagePoints = board.BoardPoints;
boardSize = board.BoardSize;
squareSize = board.SquareSize;
worldPoints = board.WorldPoints;
ImageSize = board.ImageSize;


%% explore image

filename = '2012_0524_1.JPG';
[impts, bsize, used] = detectCheckerboardPoints(filename);
bsize

%% show results

I = imread(filename);
scl = 0.6;
imshow(imresize(I,scl));
hold on
plot(scl*(impts(:,1)-0.5)+0.5,scl*(impts(:,2)-0.5)+0.5,'bo','MarkerSize',7,'LineWidth',2);
hold off


%%

% Calibrate the camera
[cameraParams, imagesUsed, estimationErrors] = estimateCameraParameters(imagePoints, worldPoints, ...
    'EstimateSkew', false, 'EstimateTangentialDistortion', false, ...
    'NumRadialDistortionCoefficients', 2, 'WorldUnits', 'inches', ...
    'InitialIntrinsicMatrix', [], 'InitialRadialDistortion', [], ...
    'ImageSize', ImageSize);

%%

% Display parameter estimation errors
displayErrors(estimationErrors, cameraParams);

%%

% View reprojection errors
figure; showReprojectionErrors(cameraParams);

%%

% Visualize pattern locations
figure; showExtrinsics(cameraParams, 'CameraCentric');


%%

% For example, you can use the calibration data to remove effects of lens distortion.
% undistortedImage = undistortImage(originalImage, cameraParams);

% See additional examples of how to use the calibration data.  At the prompt type:
% showdemo('MeasuringPlanarObjectsExample')
% showdemo('StructureFromMotionExample')
